# Einfhrendes Beispiel zu R
#
setwd("C:/Users/Alpha/Desktop/R")
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")

# Kontingenzanalyse
B=matrix(c(150,50,40,60),ncol=2,byrow=TRUE,
         dimnames=list(c("unter 30","ab 30"),c("A","B"))); B
fit=chisq.test(B,correct=FALSE); fit # Aufruf des Tests
E=fit$expected; E # Ausgabe erw. Hfgkt.
chi2_emp=sum((B-E)**2/E); chi2_emp # chi2 empirisch
chi2_krit=qchisq(1-0.01,1); chi2_krit # chi2 kritisch
if (chi2_emp>chi2_krit){"Ablehnung"} else {"keine Ab."}

# Phi coefficient
B=matrix(c(150,50,40,60),ncol=2,byrow=TRUE,
         dimnames=list(c("unter 30","ab 30"),c("A","B"))); B
library(psych); phi(B)

# Einfaktorielle Varianzanalyse
Data$Einkommen1="k=1 niedrig"
Data[which(Data$Einkommen>36),"Einkommen1"]="k=2 mittel"
Data[which(Data$Einkommen>66),"Einkommen1"]="k=3 hoch"
# Berechnung "von Hand" (zum Nachrechnen)
Data=Data[order(Data$Einkommen1,Data$Kunde),]
Data$Einkommen; Data$Einkommen1; Data$Umsatz
n=12;s=3;x=Data$Umsatz;MW=mean(x);x1=x[1:n]; MW1=mean(x1)
x2=x[(n+1):(2*n)];MW2=mean(x2);x3=x[(2*n+1):(3*n)] 
     MW3=mean(x3);MW; MW1; MW2; MW3
SQG=x-MW; SQG=SQG*SQG; SQG=sum(SQG); SQG
SQZ=n*(MW-MW1)**2+n*(MW-MW2)**2+n*(MW-MW3)**2; SQZ
SQF1=x1-MW1; SQF1=sum(SQF1*SQF1); SQF1
SQF2=x2-MW2; SQF2=sum(SQF2*SQF2); SQF2
SQF3=x3-MW3; SQF3=sum(SQF3*SQF3); SQF3
SQF=SQF1+SQF2+SQF3; SQF
MQG=SQG/(n*s-1);MQG;MQZ=SQZ/(s-1);MQZ
MQF=SQF/(n*s-s); MQF
F_emp=MQZ/MQF; F_emp # F empirisch
F_krit=qf(1-0.05,(s-1),(n*s-s)); F_krit # F kritisch
if (F_emp>F_krit){"Ablehnung"} else {"keine Ab."}
# Berechnung mit der Funktion aov (analysis of variance)
fit=aov(Umsatz~Einkommen1,data=Data); summary(fit)

# zweifaktorielle Varianzanalyse
Data$Einkommen1="k=1 niedrig"
Data[which(Data$Einkommen>36),"Einkommen1"]="k=2 mittel"
Data[which(Data$Einkommen>66),"Einkommen1"]="k=3 hoch"
fit=aov(Umsatz~Wohnort+Einkommen1+Wohnort:Einkommen1,
        data=Data); summary(fit)

# Einfachregression
fit=lm(Einkommen~Alter,data=Data); summary(fit)

# Mehrfachregression
fit=lm(Einkommen~Alter+Haushaltsgre,data=Data); summary(fit)

# Diskriminanzanalyse
library(MASS); Data$Einkommen=scale(Data$Einkommen)
Data$Alter=scale(Data$Alter)
fit=lda(Marke~Alter+Einkommen,data=Data); fit
b=fit$scaling[,1]; laenge=sqrt(b[1]**2+b[2]**2)
b=b/laenge; b
Marke_pred=predict(fit,newdata=Data)$class
table(Data$Marke,Marke_pred) # Kreuztabelle

# Multiple Diskriminanzanalyse mit lda
Data$Haushaltsgre=scale(Data$Haushaltsgre)
Data$Umsatz=scale(Data$Umsatz)
fit=lda(Status~Alter+Einkommen+Haushaltsgre+
          Umsatz,data=Data)
fit; pred=predict(fit,dimen=2,newdata=Data); pred$x
table(Data$Status,pred$class) # Prognose mit zwei Dimens.
pred=predict(fit,dimen=1,newdata=Data); pred$x
table(Data$Status,pred$class) # Prognose mit einer Dimens.

# Faktorenanalyse (Hauptkomponentenmethode)
# Berechnung "von Hand"
X=as.matrix(scale(Data[,c(3,2,4,5)])); cov(X)
n=dim(X)[1]; m=dim(X)[2]
S=(t(X)%*%X)/(n-1); S
lambda=eigen(S)$values; lambda
B=eigen(S)$vectors; B
Y=X%*%B; cov(Y)
# Berechnung mit der Funktion prcomp
X=scale(Data[,c(3,2,4,5)])
fit=prcomp(X,scale=TRUE); summary(fit)
B=fit$rotation; B
Y=predict(fit); cov(Y); biplot(fit)

# Clusteranalyse
Data=scale(Data[,c(3,2)]) # Standardisierung
Dist=dist(Data,method="euclid") # euklidische Distanz
fit=hclust(Dist,method="average") # hier. Clusteranalyse
plot(fit) # Dendrogramm
fit=kmeans(Data,2,iter.max=100) # kmeans bei 2 Klassen
fit$tot.withinss # Abweichungsquadratsumme

# Conjointanalyse
Data=read.csv("beispiel2.csv",header=TRUE,sep=";",dec=",") 
Data$Praefwert=1+max(Data$R1)-Data$R1 # z.B. fuer Kunde 1
fit=lm(Praefwert~A_Ergonomie+B_Sicherheit+C_Nettopreis+
         D_Bedienung,data=Data); b=fit$coefficients; b
NB=matrix(0,nrow=4,ncol=3); NBmin=1:4; NBmax=1:4
NB[1,2]=b[2]; NB[1,3]=b[3]; NB[2,2]=b[4]; NB[2,3]=b[5]
NB[3,2]=b[6]; NB[3,3]=b[7]; NB[4,2]=b[8]; NB[4,3]=b[9]
NB; Summe=0; for (j in 1:4){ NBmin[j]=min(NB[j,])
NBmax[j]=max(NB[j,]);Summe=Summe+(NBmax[j]-NBmin[j])}
for (j in 1:4){for (k in 1:3) {
  NB[j,k]=(NB[j,k]-NBmin[j])/Summe}}; NB

# Beispiel zum Entscheidungsbaumverfahren und Vergleich
library(MASS); library(ROCR); library(hmeasure)
library(tree); library(maptree); library(partykit)
library(nnet); library(ggrepel)
Data=read.csv("Beispiel1.csv",header=TRUE,sep=";",dec=",")
# Aufteilen der Daten in Train und Test
set.seed(1234)
n=dim(Data)[1]; n2=round(0.8*n); tr=sample(1:n,n2)
Data.train=Data[tr,]; Data.test=Data[-tr,]
Data.train$Besteller=as.factor(Data.train$Besteller)
Data.test$Besteller=as.factor(Data.test$Besteller)
Data.formula=Besteller~Alter+Einkommen
# Diskriminanzanalyse
lda.fit=lda(Data.formula,Data.train); lda.fit
lda.scores.train=predict(lda.fit,Data.train)$posterior[, 2]
lda.scores.test=predict(lda.fit,Data.test)$posterior[, 2]
# Entscheidungsbaum mit tree-package
tree.fit=tree(Data.formula,data=Data.train, method="recursive.partition",
              split="gini",mincut=8,mindev=0)
draw.tree(tree.fit)
tree.scores=predict(tree.fit,Data)[,2]
tree.scores.train=predict(tree.fit,Data.train)[,2]
tree.scores.test=predict(tree.fit,Data.test)[,2]
# Entscheidungsbaum mit party-package
ctree.fit=ctree(Data.formula, data=Data.train,maxdepth=2,
                mincriterion=0,minsplit=0,minbucket=0)
plot(ctree.fit,gp=gpar(fontsize=10))
a=predict(ctree.fit,Data.train,type="prob") 
n=dim(Data.train)[1]; ctree.scores.train=1:n 
for (i in 1:n){ctree.scores.train[i]=a[i,2]}
a=predict(ctree.fit,Data.test,type="prob") 
n=dim(Data.test)[1]; ctree.scores.test=1:n 
for (i in 1:n){ctree.scores.test[i]=a[i,2]}
# Neuronales Netz mit nnet-package
nnet.fit <- nnet(Data.formula,Data.train,size=15,maxit=300)
nnet.fit; nnet.scores.train=predict(nnet.fit,Data.train)
nnet.scores.test= predict(nnet.fit,Data.test)
# Plots und AUC-Werte fr train
scores=data.frame(LDA=lda.scores.train, 
                  Tree=tree.scores.train,CTree=ctree.scores.train,
                  NNet=nnet.scores.train)
results=HMeasure(Data.train$Besteller,scores)
plotROC(results); results$metrics
# Plots und AUC-Werte fr test
scores=data.frame(LDA=lda.scores.test,
                  Tree=tree.scores.test,CTree=ctree.scores.test,
                  NNet=nnet.scores.test)
results=HMeasure(Data.test$Besteller,scores)
plotROC(results); results$metrics
